package net.plil.clubinfo.etunicorn.app.debit;

import android.content.Context;
import android.os.Bundle;
import android.support.design.widget.CoordinatorLayout;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TextInputEditText;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;

import com.android.volley.AuthFailureError;
import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;

import net.plil.clubinfo.etunicorn.R;
import net.plil.clubinfo.etunicorn.app.MainActivity;
import net.plil.clubinfo.etunicorn.app.NFCSupport;
import net.plil.clubinfo.etunicorn.data.Personne;
import net.plil.clubinfo.etunicorn.utils.VolleyUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class Debiter extends Fragment implements NFCSupport {


    private TextInputEditText mMoneyEditText;
    private ProgressBar mProgressBar;
    private CoordinatorLayout coordinatorLayout;

    public Debiter() {
        // Required empty public constructor

    }

    public static Debiter newInstance() {
        return new Debiter();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);


    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_debiter, container, false);
        mProgressBar = (ProgressBar) view.findViewById(R.id.debiter_progress);
        mMoneyEditText = (TextInputEditText) view.findViewById(R.id.debiter_edit_text_money);
        coordinatorLayout = (CoordinatorLayout) view.findViewById(R.id.debiter_layout);
        return view;
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
    }

    @Override
    public void onDetach() {
        super.onDetach();
    }

    @Override
    public void processNFC(String iDCardUser) {
        if (mMoneyEditText.getText().toString().isEmpty()) {
            mMoneyEditText.setError(getString(R.string.error_enter_debit));
            return;
        }
        mMoneyEditText.setVisibility(View.GONE);
        mProgressBar.setVisibility(View.VISIBLE);
        JSONObject jsonObject = new JSONObject();
        //TODO verifier champ complet avant de construire la requete
        try {
            Personne p = new Personne();
            p.setCarte(iDCardUser);
            jsonObject.put("participant", p);
            jsonObject.put("prix", -Double.parseDouble(mMoneyEditText.getText().toString()));
            mMoneyEditText.setError(null);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        JsonObjectRequest jsonObjectRequest = new JsonObjectRequest(Request.Method.POST, VolleyUtils.baseUri + "/transaction/credit", jsonObject, new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {
                mProgressBar.setVisibility(View.GONE);
                mMoneyEditText.setText("");
                mMoneyEditText.setVisibility(View.VISIBLE);
                Snackbar.make(coordinatorLayout, "DONE", Snackbar.LENGTH_LONG).show();

            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                mProgressBar.setVisibility(View.GONE);
                mMoneyEditText.setVisibility(View.VISIBLE);
                Snackbar.make(coordinatorLayout, error.getMessage(), Snackbar.LENGTH_LONG).show();

            }
        }) {
            @Override
            public Map<String, String> getHeaders() throws AuthFailureError {
                Map<String, String> headers = new HashMap<>();
                headers.put("Authorization", MainActivity.session.getToken());
                return headers;
            }
        };
        jsonObjectRequest.setTag(Debiter.class);
        VolleyUtils.getInstance(getContext()).addToRequestQueue(jsonObjectRequest);
    }

    @Override
    public void onStop() {
        VolleyUtils.getInstance(getContext()).getRequestQueue().cancelAll(Debiter.class);
        super.onStop();
    }
}
